#!/usr/bin/perl -w
use strict;
print 'Enter Source IP: ';
my $YourIP = <STDIN>;
chomp $YourIP;
print "No Source IP given.\n\n" and exit if !$YourIP;
print "Not a valid Source IP.\n\n" and exit if !valid_ip($YourIP);
print 'Enter Target IP: ';
my $TargetIP = <STDIN>;
chomp $TargetIP;
print "No Target IP given.\n\n" and exit if !$TargetIP;
print "Not a valid Target IP.\n\n" and exit if !valid_ip($TargetIP);
print 'Do you want the rules to write to a file (y/n): ';
my $write_file = <STDIN>;
chomp $write_file;
$write_file = 1 if grep { lc $write_file eq $_ } qw(y yes);
open my $out, '>rules.txt', or die "Unable to open file : $!"
if $write_file == 1;
my @portr =
31000 31100
32300 32400
33600 33700
qw(30000 30100 30200 30300 30400 30500 30600 30700 30800 30900
31200 31300 31400 31500 31600 31700 31800 31900 32000 32100 32200
32500 32600 32700 32800 32900 33000 33100 33200 33300 33400 33500
33800 33900 34000 34100);
for my $portr (@portr) {
for (my $port = $portr; $port <= $portr + 20; $port++) {
my $rule =
"iptables -t nat -A PREROUTING --dst $YourIP -p tcp --dport $port -j DNAT --todestination
$TargetIP
iptables -t nat -A POSTROUTING -p tcp --dst $TargetIP --dport $port -j SNAT --tosource
$YourIP
iptables -t nat -A OUTPUT --dst $YourIP -p tcp --dport $port -j DNAT --todestination
$TargetIP";
if ($write_file == 1) {
print $out "$rule\n\n";
}
else {
system $rule;
}
}
}
close $out if $write_file == 1;
sub valid_ip {
my $ip = shift;
return 0 if $ip !~ /^\d{1,3}[.]\d{1,3}[.]\d{1,3}[.]\d{1,3}$/;
return 1;
}
