function version_compare(v1, v2, operator) {
    this.php_js = this.php_js || {};
    this.php_js.ENV = this.php_js.ENV || {};
    var i = 0,
        x = 0,
        compare = 0,
        vm = {
            'dev': -6,
            'alpha': -5,
            'a': -5,
            'beta': -4,
            'b': -4,
            'RC': -3,
            'rc': -3,
            '#': -2,
            'p': -1,
            'pl': -1
        },
        prepVersion = function (v) {
            v = ('' + v).replace(/[_\-+]/g, '.');
            v = v.replace(/([^.\d]+)/g, '.$1.').replace(/\.{2,}/g, '.');
            return (!v.length ? [-8] : v.split('.'));
        },
        numVersion = function (v) {
            return !v ? 0 : (isNaN(v) ? vm[v] || -7 : parseInt(v, 10));
        };
    v1 = prepVersion(v1);
    v2 = prepVersion(v2);
    x = Math.max(v1.length, v2.length);
    for (i = 0; i < x; i++) {
        if (v1[i] == v2[i]) {
            continue;
        }
        v1[i] = numVersion(v1[i]);
        v2[i] = numVersion(v2[i]);
        if (v1[i] < v2[i]) {
            compare = -1;
            break;
        } else if (v1[i] > v2[i]) {
            compare = 1;
            break;
        }
    }
    if (!operator) {
        return compare;
    }
    switch (operator) {
        case '>':
        case 'gt':
            return (compare > 0);
        case '>=':
        case 'ge':
            return (compare >= 0);
        case '<=':
        case 'le':
            return (compare <= 0);
        case '==':
        case '=':
        case 'eq':
            return (compare === 0);
        case '<>':
        case '!=':
        case 'ne':
            return (compare !== 0);
        case '':
        case '<':
        case 'lt':
            return (compare < 0);
        default:
            return null;
    }
}
function startLoading() {
    "use strict";
    var loader = jQuery("<div id=\"loader\"><span><img src=\"" + window.url + "/templates/default/vps/images/spinner.gif\"/></span></div>");
    var top = $(window).height() / 2;
    loader.children("span").css("margin-top", top);
    jQuery("body").prepend(loader);
}

function endLoading() {
    "use strict";
    jQuery("#loader").remove();
}

function LoadCloudTemplates(id, el) {
    "use strict";
    startLoading();
    $("#cluster li.selected").removeClass("selected");
    $(el).parent().addClass("selected");
    jQuery("#templatediv").html("");
    jQuery("#descriptionwrapw").hide();
    jQuery("#groupsdiv").load(window.url + "/modules/addons/vpsnet/vpsnet-ajax.php?m=templatesgroups&c=" + id, function () {
        endLoading();
    });
    jQuery("#templatedesc").html("");

}



function getTemplates(cloud, id, el) {
    "use strict";
    $("#groupsdiv li.selected").removeClass("selected");
    $(el).parent().addClass("selected");
    jQuery("#templatedivwrap").hide();
    jQuery("#templatedesc").html("");
    jQuery("#descriptionwrapw").hide();
    startLoading();
    jQuery("#templatediv").load(window.url + "/modules/addons/vpsnet/vpsnet-ajax.php?m=cloudtemplates&c=" + cloud + "&templates=" + escape(id), function () {
        endLoading();
    });
}

function getTemplatesDesc(cloud, id, el) {
    "use strict";
    $("#templatediv li.selected").removeClass("selected");
    $(el).parent().addClass("selected");
    startLoading();

    jQuery.getJSON(window.url + "/modules/addons/vpsnet/vpsnet-ajax.php?m=templatedesc&id=" + id + "&c=" + cloud, function (response) {
        endLoading();
        jQuery("#templatedesc").val(response.description);
        $.each(response.prices, function (ind, val) {
            jQuery("input[name=price\\[" + ind + "\\]]").val(val);
        });

        jQuery("#templatename").val(response.name);
        jQuery("#descriptionwrapw").show();
    });
}

function manageconfigoptions(id) {
    "use strict";
    window.open(window.url + "/modules/addons/vpsnet/vpsnet.php?action=setnprice&pid=" + id, "configoptions", "width=900,height=500,scrollbars=yes");
}

$(function () {
    "use strict";
    $.ajax({
        url: window.location.protocol + "//www.vps.net/whmcs/current-version.txt",
        dataType: "jsonp",
        timeout: 10000,
        jsonp: "callback",
        jsonpCallback: "jsonpCallback",
        success: function (data) {
            if (window.version_compare(data, window.current_version, ">")) {
                $(".versionbox strong b").text(data);
                $(".versionbox").show();
            }
        }
    });

    if (jQuery.fn.dataTable) {
        $("#clservers").dataTable({
            "bPaginate": false
        });
    }

    $(".show-users").click(function (e) {
        e.preventDefault();
        $("input[name=vpsid]").val($(this).attr("rel"));
        $("#users").dialog("open");

    });
    $(".show_full_info").click(function (e) {
        e.preventDefault();
        startLoading();
        $.get(window.url + "/modules/addons/vpsnet/vpsnet-ajax.php", {
            id: $(this).attr("rel"),
            m: "serverinfo"
        }, function (data) {
            endLoading();
            var dialog = $("<div></div>")
                .html(data)
                .dialog({
                modal: true,
                width: 500,
                title: "Server info",
                buttons: {
                    Ok: function () {
                        $(this).dialog("close");
                        dialog.remove();
                    }
                }
            });
        });
    });
    $(".detachvps").click(function () {
        if (confirm("Are sure wish to detach this VPS?")) {
            startLoading();
            return true;
        }
        return false;
    });
    $("#users").dialog({
        height: 210,
        width: 430,
        modal: true,
        autoOpen: false,
        buttons: {
            "Assign": function () {
                var ulrs = $("#assignServer").serialize();
                window.location.href = window.modulelink + "&" + ulrs;
                $(this).dialog("close");
            },
            "Cancel": function () {
                $(this).dialog("close");
            }
        }
    });

    $("#assignUser").change(function () {
        var cur_cust_products = window.client_prods[$(this).val()];
        var opt = "";
        $.each(cur_cust_products, function (ind, item) {
            opt += "<option value=\"" + item.id + "\">" + item.title + "</option>";
        });
        $("#cust_products").html(opt);
    });

    $("#descriptionwrapw").submit(function (e) {
        e.preventDefault();
        var cloud_id = $("#cluster li.selected .cloud").val();
        var template_id = $("#templatediv li.selected .template").val();
        var post = $(this).serializeArray();
        var forms = {};
        $.each(post, function (key, v) {
            forms[v.name] = v.value;
        });
        var postarg = $.extend({}, forms, {
            "cloud_id": cloud_id,
            "id": template_id
        });
        startLoading();
        $.post(window.url + "/modules/addons/vpsnet/vpsnet-ajax.php?m=savetemplate", postarg, function () {
            endLoading();
            var dialog = $("<div></div>")
                .html("Changes have been saved!")
                .dialog({
                modal: true,
                title: "Success",
                buttons: {
                    Ok: function () {
                        $(this).dialog("close");
                        dialog.remove();
                    }
                }
            });
        });
    });


    $("#cluster .cloud").click(function () {
        var me = $(this);
        $.post(window.url + "/modules/addons/vpsnet/vpsnet-ajax.php?m=togglecloud", {
            "cloud_id": me.val(),
            "enabled": me.is(":checked")
        }, function () {
            var dialog = $("<div></div>")
                .html("Cloud has been " + (me.is(":checked") ? "enabled" : "disabled") + " !")
                .dialog({
                modal: true,
                title: "Success",
                buttons: {
                    Ok: function () {
                        $(this).dialog("close");
                        dialog.remove();
                    }
                }
            });
        });
    });

    $("#groupsdiv, #templatediv").click(function () {
        $("#cloudPrice").hide();
    });

    $("#cluster a").click(function (e) {
        e.preventDefault();
        $("#descriptionwrapw").hide();
        var cloudid = $(this).data("cloud-id");
        LoadCloudTemplates(cloudid, $(this));
        if ($(this).hasClass("anotherPrice")) {
            $("#cloudPrice").show();
            var cprice = window.cprices[cloudid];
            if (window.cprices[cloudid]) {
                $.each(cprice, function (curId, value) {
                    $("#cloudPrice input[name=vpsprice\\[" + curId + "\\]]").val(value);
                });
            }
            else {
                $("#cloudPrice input").val("");
            }
        } else {
            $("#cloudPrice").hide();
        }
        var prempr = $(this).data("premium-price");
        if (parseFloat(prempr, 10) > 0) {
            $(".premium-title span").text(prempr);
            $(".premium-title").show();
        } else {
            $(".premium-title").hide();
        }
        $(".cloudname").val($(this).text());

    });
    $("#groupsdiv .templategroup").click( function () {
        var me = $(this);
        var cloud_id = $("#cluster li.selected .cloud").val();
        $.post(window.url + "/modules/addons/vpsnet/vpsnet-ajax.php?m=toggletemplategroup", {
            "cloud_id": cloud_id,
            "name": me.val(),
            "enabled": me.is(":checked")
        }, function () {
            var dialog = $("<div></div>")
                .html("Template group has been " + (me.is(":checked") ? "enabled" : "disabled") + " !")
                .dialog({
                modal: true,
                title: "Success",
                buttons: {
                    Ok: function () {
                        $(this).dialog("close");
                        dialog.remove();
                    }
                }
            });
        });
    });
    $("#cloudPrice").submit(function (e) {
        e.preventDefault();
        var data = $(this).serializeArray();
        var c_id = $("#cluster li.selected .cloud").val();


        $("#cluster li.selected a").text($(".cloudname").val());


        data.push({
            "name": "cloud_id",
            value: c_id
        });

        $.post(window.url + "/modules/addons/vpsnet/vpsnet-ajax.php?m=cloudprice", data, function (response) {
            window.cprices[c_id] = response;
            var dialog = $("<div></div>")
                .html("Changes have been saved!")
                .dialog({
                modal: true,
                title: "Success",
                buttons: {
                    Ok: function () {
                        $(this).dialog("close");
                        dialog.remove();
                    }
                }
            });
        }, "json");
    });

    $("#templatediv .template").click( function () {
        var me = $(this);
        var cloud_id = $("#cluster li.selected .cloud").val();
        $.post(window.url + "/modules/addons/vpsnet/vpsnet-ajax.php?m=toggletemplate", {
            "cloud_id": cloud_id,
            "id": me.val(),
            "enabled": me.is(":checked")
        }, function () {
            var dialog = $("<div></div>")
                .html("Template has been " + (me.is(":checked") ? "enabled" : "disabled") + " !")
                .dialog({
                modal: true,
                title: "Success",
                buttons: {
                    Ok: function () {
                        $(this).dialog("close");
                        dialog.remove();
                    }
                }
            });
        });
    });


    $(".delenodes", "#nodesForm").click(function () {
        var checked = $("#nodesForm .delenodes:checked");
        var checkedU = $("#nodesForm .users.delenodes:checked");

        if (checked.length > 0) {
            if (checkedU.length > 0) {
                $("button[value=detach]").attr("disabled", false);
                if (checked.length > checkedU.length) {
                    $("button[value=assign], button[value=detach]").attr("disabled", true);
                }
            } else {
                $("button[value=delete], button[value=assign]").attr("disabled", false);
            }
        } else {
            $("button[value=delete], button[value=assign], button[value=detach]").attr("disabled", true);
        }
    });


    $("#assignNodes").click(function (e) {
        e.preventDefault();
        $("#assingNodesDialog").dialog({
            height: 180,
            width: 400,
            modal: true,
            autoOpen: false,
            buttons: {
                "Assign": function () {
                    $("#nodesForm").append("<input type=\"hidden\" name=\"nact\" value=\"assign\"/>" +
                        "<input type=\"hidden\" name=\"service_id\" value=\"" + $("#assignUser").val() + "\"/>")
                        .submit();
                    $(this).dialog("close");
                },
                "Cancel": function () {
                    $(this).dialog("close");
                }
            }
        });
        $("#assingNodesDialog").dialog("open");
    });


    $("input[name=\"enabled[]\"]").click(function () {
        if ($(this).is(":checked")) {
            $(this).parent().next(".pricecont").show();
        } else {
            $(this).parent().next(".pricecont").hide();
        }
    });

    
});
