(function ($, undefined) {
	"use strict";
	$.fn.extend({
		vn_nodes_slider: function (options) {
			var defaultOptions = {
				minShownNodes: 0,
				nodeCost: {},
				storageCost: {},
				ramCost: {},
				initialNodes: {
					"regular" : 2
					
				},
				
				curSign: "&pound;",
				MoveNodesForward: function (el, nodeType) {
					var par = $(el).parent();
					var current = $(".ui-slider", par).slider("value");
					var max = Math.min(current + 15, opt.maxAssignable[nodeType]); //locically, isn't it?
					var min = Math.max(max - 15, 1);
					var range = [];
					for (var i = min; i <= max; i++) {
						range.push(i);
					}
					var slpar = $(".slider-nodes", par);
					$("li", slpar).hide();
					$("li", slpar).slice($("li[data-ind=\"" + (min) + "\"]", slpar).index(), $("li[data-ind=\"" + (max) + "\"]", slpar).index() + 1).show();
					$(".ui-slider", par).slider("option", "min", min);
					$(".ui-slider", par).slider("option", "max", max);
					$(".nodes-next", par).hide();
					$(par).find(".ui-slider").css("margin-left", ((37.06) * Math.min(min - opt.minAssignable[nodeType], 0) + 17) + "px");
					$(par).find(".ui-slider").css("width", ((37.06) * (range.length - 1)) + "px");
					if (min === current) {
						$(".nodes-prev", par).show();
					}
					return;
				},
				MoveNodesBack: function (el, nodeType) {
					var par = $(el).parent();
					var slpar = $(".slider-nodes", par);
					var current = $(".ui-slider", par).slider("value");
					var max = Math.max(current, Math.min(opt.maxAssignable[nodeType], 15 + opt.minShown[nodeType]));
					var min = Math.max(max - 15, parseInt($("li:eq(0)", slpar).data("ind"), 10));
					var range = [];
					for (var i = min; i <= max; i++) {
						range.push(i);
					}
					$(par).find(".ui-slider").css("margin-left", ((37.06) * Math.max(opt.minAssignable[nodeType] - min, 0) + 17) + "px");
					$(par).find(".ui-slider").css("width", ((37.06) * (Math.min(16, opt.maxAssignable[nodeType]) - Math.max(opt.minAssignable[nodeType] - min, 0) - 1)) + "px");
					$("li", slpar).hide();
					$("li", slpar).slice($("li[data-ind=\"" + (min) + "\"]", slpar).index(), $("li[data-ind=\"" + (max) + "\"]", slpar).index() + 1).show();
					$(".ui-slider", par).slider("option", "min", Math.max(min, opt.minAssignable[nodeType]));
					$(".ui-slider", par).slider("option", "max", max);
					if (max === current) { $(".nodes-next", par).show(); }
					$(".nodes-prev", par).hide();
				},
				setTotalValues: function (nodes_params) {
					var nodes = $("#num-nodes").val();
					var storagenodes = $("#storage-num-nodes").val();
					var ramnodes = $("#ram-num-nodes").val();
					var price = 0;
					if (opt.rsync_price > 0) {
						price = (nodes_params.regular.storage * nodes + nodes_params.storage.storage * storagenodes) * opt.rsync_price;
						$("#price_for_rsync").html(price.toFixed(2));
					}
					if (opt.snapshot_price > 0) {
						price = (nodes_params.regular.storage * nodes + nodes_params.storage.storage * storagenodes) * opt.snapshot_price;
						$("#price_for_snapshot").html(price.toFixed(2));
					}

					var finalbandwidth = nodes * nodes_params.regular.bandwidth;
					var bandwidthLabel;

					if (finalbandwidth >= 1024) {
						bandwidthLabel = (finalbandwidth / 1024).toFixed(0) + "TB";
					} else {
						bandwidthLabel = finalbandwidth.toFixed(0) + "GB";
					}

					$("#vps-net-slider .cpu p").text(
					((nodes * nodes_params.regular.cpu) / 1000) + "GHz");
					$("#vps-net-slider .ram p").text(
					(nodes * nodes_params.regular.ram + ramnodes * nodes_params.ram.ram) + "MB");
					$("#vps-net-slider .storage p").text(
					(nodes * nodes_params.regular.storage + storagenodes * nodes_params.storage.storage) + "GB");
					$("#vps-net-slider .bandwidth p").text(bandwidthLabel);

					if ($("#vps-net-slider .nodesused").is("*")) {
						$("#vps-net-slider .nodesused p").text(nodes + "+" + storagenodes + "+" + ramnodes);
					}
					// Only Price it up if the price is shown
					if ($("#vps-net-slider .price").is("*")) {
						var num = (opt.nodeCost[nodes] + opt.storageCost[storagenodes] + opt.ramCost[ramnodes]);
						$("#vps-net-slider .price span.cost").html(num.toFixed(2));
						var fncost = (0).toFixed(2),
							ncost = 0,
							scost = 0,
							rcost = 0;
						if (nodes > 0) {
							ncost = (opt.nodeCost[nodes] / nodes);
							fncost = ncost.toFixed(2);
						}
						if (storagenodes > 0) {
							scost = opt.storageCost[storagenodes] / storagenodes;
							fncost = ncost.toFixed(2) + "/" + scost.toFixed(2);
						}
						if (ramnodes > 0) {
							rcost = opt.ramCost[ramnodes] / ramnodes;
							fncost = ncost.toFixed(2) + "/" + rcost.toFixed(2);
						}
						$("#vps-net-slider .price p.saving").html(fncost + " per node");
					}
				}
			};
			var opt = $.extend(true, defaultOptions, options);

			var nodes_params = {
				regular : {
					"cpu" : 2400, /* In MHZ */
					"ram" : 512, /* In MB */
					"storage" : 10, /* In GB */
					"bandwidth" : 1024 * 3 /* In GB*/
				},
				ram : {
					"ram" : 512 /* In MB */
				},
				storage : {
					"storage" : 25 /* In GB */
				}
			};


			/* Slider settings */
			$("#num-nodes").val(opt.initialNodes.regular);
			
			for (var i = Math.min(opt.minShown.regular, 1); i <= opt.maxAssignable.regular; i++) {
				$("#slider-nodes").append("<li data-ind=\"" + i + "\">" + i + "</li>");
			}

			$("#slider-nodes li").slice(16).hide();

			$("#storage-slider-nodes").append("<li data-ind=\"0\">0</li>");
			for (i = 1; i <= opt.maxAssignable.storage; i++) {
				$("#storage-slider-nodes").append("<li data-ind=\"" + i + "\">" + i + "</li>");
			}

			$("#storage-slider-nodes li").slice(16).hide();

			$("#ram-slider-nodes").append("<li data-ind=\"0\">0</li>");
			for (i = 1; i <= opt.maxAssignable.ram; i++) {
				$("#ram-slider-nodes").append("<li data-ind=\"" + i + "\">" + i + "</li>");
			}

			$("#ram-slider-nodes li").slice(16).hide();

			var selectedNodes = $("#num-nodes").val();
			var selectedStorageNodes = $("#storage-num-nodes").val();
			var selectedRamNodes = $("#ram-num-nodes").val();

			var assignedNodes = selectedNodes > 0 ? selectedNodes : opt.initialNodes.regular;
			var assignedStorageNodes = selectedStorageNodes > 0 ? selectedStorageNodes : opt.initialNodes.storage;
			var assignedRamNodes = selectedRamNodes > 0 ? selectedRamNodes : opt.initialNodes.ram;

			var size = Math.min(opt.maxAssignable.regular, 15 + opt.minShown.regular);

			$("#regular-slider").css("width", ((37.06) * (size - opt.minAssignable.regular)) + "px");
			$("#regular-slider").css("margin-left", ((37.06) * (opt.minAssignable.regular - opt.minShown.regular) + 17) + "px");
			$("#regular-slider ~ .nodes-prev").click(function () {
				opt.MoveNodesBack(this, "regular");
			});
			$("#regular-slider ~ .nodes-next").click(function () {
				opt.MoveNodesForward(this, "regular");
			});

			size = Math.min(opt.maxAssignable.storage, 15);

			$("#storage-slider").css("width", ((37.06) * (size - opt.minAssignable.storage)) + "px");
			$("#storage-slider").css("margin-left", ((37.06) * (opt.minAssignable.storage) + 17) + "px");
			$("#storage-slider ~ .nodes-prev").click(function () {
				opt.MoveNodesBack(this, "storage");
			});
			$("#storage-slider ~ .nodes-next").click(function () {
				opt.MoveNodesForward(this, "storage");
			});

			size = Math.min(opt.maxAssignable.ram, 15);
			$("#ram-slider").css("width", ((37.06) * (size - opt.minAssignable.ram)) + "px");
			$("#ram-slider").css("margin-left", ((37.06) * (opt.minAssignable.ram) + 17) + "px");
			$("#ram-slider ~ .nodes-prev").click(function () {
				opt.MoveNodesBack(this, "ram");
			});
			$("#ram-slider ~ .nodes-next").click(function () {
				opt.MoveNodesForward(this, "ram");
			});

			opt.setTotalValues(nodes_params);

			var sliderChange = function (e, ui) {
				var t = $(this);
				var x = ui.value;
				var par = t.parent();
				var find = $(".slider-nodes li:eq(0)", par).data("ind");
				var smin = 0;
				var smax = x + 1;
				var nodeType = t.attr("id").replace("-slider", "");
				$(t).find("input").val(x);
				$(".slider-nodes li", par).removeClass("active");

				if (find === 0) {
					smin = 1;
				} else {
					--smax;
				}

				$(".slider-nodes li", par).slice(smin, smax).addClass("active");

				if ((x === $(t).slider("option", "max")) && (x < $(".slider-nodes li:last", par).data("ind"))) {
					$(".nodes-next", par).show();
				} else {
					$(".nodes-next", par).hide();
				}
				if (x === $(t).slider("option", "min") &&
					x > $(".slider-nodes li:first", par).data("ind") &&
					$(".slider-nodes li:visible:first", par).data("ind") >  opt.minShown[nodeType]) {
					$(".nodes-prev", par).show();
				} else {
					$(".nodes-prev", par).hide();
				}
				opt.setTotalValues(nodes_params);
			};

			var maximus = Math.min(opt.maxAssignable.regular, 15 + opt.minShown.regular);
			$("#regular-slider.ui-slider").slider({
				min: opt.minAssignable.regular,
				max: maximus,
				animate: true,
				change: sliderChange,
				slide: sliderChange
			});

			if (opt.assignedNodes > 15 + opt.minShown.regular) {
				opt.MoveNodesForward();
			}
			$("#regular-slider.ui-slider").slider("value", assignedNodes);

			var maximusS =  Math.min(opt.maxAssignable.storage, 15);

			$("#storage-slider.ui-slider").slider({
				min: opt.minAssignable.storage,
				max: maximusS,
				animate: true,
				change: sliderChange,
				slide: sliderChange
			});
			if (assignedStorageNodes > 15) {
				opt.MoveStorageNodesForward();
			}
			$("#storage-slider.ui-slider").slider("value", assignedStorageNodes);

			var maximur =  Math.min(opt.maxAssignable.ram, 15);

			$("#ram-slider.ui-slider").slider({
				min: opt.minAssignable.ram,
				max: maximur,
				animate: true,
				change: sliderChange,
				slide: sliderChange
			});
			if (assignedRamNodes > 15) {
				opt.MoveRamNodesForward();
			}
			$("#ram-slider.ui-slider").slider("value", assignedRamNodes);
			$("#nodestab").show();
			$("#storagetab").hide();
			$("#ramtab").hide();
		}
	});
})(jQuery);
