<?php
//error_reporting(E_ALL & ~E_NOTICE);

//ini_set('display_errors', 1);

class vps {
	
	/**
	 * vps.net API class instance
	 *
	 * @var VPSNET
	 */
	private $vpsNetApi;
	public $pid;
	private $clouds = false;
	
	/**
	 * Client's node list when populated by vps::updateNodes() 
	 *
	 * @var array List of node objects
	 */
	private $nodes = false;
	
	public function __construct() {
		//error_reporting(E_ALL);
		$this->getApiInstance();
	}
	
	/**
	 * Return a pointer to the api object (PHP5 else this won't work right)
	 *
	 * @return VPSNET
	 */
	public function api() {
		return $this->vpsNetApi;
	}
	
	public function getServiceId($clientId = false) {
		if ($clientId == false) {
			if(!isset($_SESSION['uid'])) {
				return 0;
			}
			$clientId = $_SESSION['uid'];
		}
		$clientId = (int) $clientId;
		
		$result = select_query("tblhosting", "id", "packageid = {$this->getPid()} and userid = {$clientId}");
                if(!$result) return 0;
		if(mysql_num_rows($result) == 0) {
			return 0;
		}
		$data = mysql_fetch_assoc($result);
		return (int) $data['id'];
	}
	
	public function setNodes() {
		
	}

    public function getStorageNodesConfigOptionId ($numStorageNodes= false) {

        $return=array();
		$result = full_query("
			SELECT id FROM tblproductconfigoptions
			WHERE optionname
			LIKE 'vpsnetNumStorage|%'
		");

		$data = mysql_fetch_assoc($result);
		$configId = (int) $data['id'];
        if($numStorageNodes !== false){
            $result = full_query("
                    SELECT id
                    FROM tblproductconfigoptionssub
                    WHERE configid = {$configId} AND (optionname LIKE '{$numStorageNodes}|%' OR optionname = '{$numStorageNodes}')
            ");
            $data = mysql_fetch_assoc($result);
            $id = (int) $data['id'];

            $return[$configId] = $id;
            return $return;
        }
        return $configId;
        }


        public function getRamNodesConfigOptionId ($numRamNodes= false) {

                $return=array();

		$result = full_query("
			SELECT id FROM tblproductconfigoptions
			WHERE optionname
			LIKE 'vpsnetNumRam|%'
		");

		$data = mysql_fetch_assoc($result);
		$configId = (int) $data['id'];
                if($numRamNodes !== false){
                    $result = full_query("
                            SELECT id
                            FROM tblproductconfigoptionssub
                            WHERE configid = {$configId} AND (optionname LIKE '{$numRamNodes}|%' OR optionname = '{$numRamNodes}')
                    ");
                    $data = mysql_fetch_assoc($result);
                    $id = (int) $data['id'];

                    $return[$configId] = $id;
                    return $return;
                }
                return $configId;
        }


	public function getNodesConfigOptionId($numNodes = null,$numStorageNodes=0,$numRamNodes=0) {
		$result = full_query("
			SELECT id FROM tblproductconfigoptions
			WHERE optionname
			LIKE 'vpsnetNumNodes|%'
		");
		$data = mysql_fetch_assoc($result);
		$configId = (int) $data['id'];
        if($numNodes != null){
            $result = full_query("
                    SELECT id
                    FROM tblproductconfigoptionssub
                    WHERE configid = {$configId} AND (optionname LIKE '{$numNodes}|%' OR optionname = '{$numNodes}')
            ");
            $data = mysql_fetch_assoc($result);
            $id = (int) $data['id'];

            $return=array();

            $return[$configId] = $id;

            if ($numStorageNodes) {
                foreach ($this->getStorageNodesConfigOptionId($numStorageNodes) as  $key=>$value) {
                    $return[$key]=$value;
                }
            }
            if ($numRamNodes) {
                foreach ($this->getRamNodesConfigOptionId($numRamNodes) as  $key=>$value) {
                    $return[$key]=$value;
                }
            }
            return $return;
        }
        return $configId;
	}
	
	/**
	 * Update node list
	 *
	 * @param bool $conditional True to only update nodes if the list hasn't been fetched before
	 */
	public function updateNodes($conditional = false) {
		if ($conditional != false && $this->nodes !== false) {
			return;
		}
		$this->nodes = $this->api()->getNodes($this->getServiceId());
	}
	
	/**
	 * Get total count of client's nodes
	 *
	 * @return int Total nodes
	 */
	public function getNodeCount() {
		$this->updateNodes(true);
		return count($this->nodes);
	}
	
	/**
	 * Get client's nodes
	 *
	 * @return array List of node objects
	 */
	public function getNodes() {
		$this->updateNodes(true);
		return $this->nodes;
	}


	/**
	 * Retrieve list of node prices as configured in WHMCS
	 *
	 * @return array
	 */
	public function getNodePrices($currency=0) {

                if ($currency==0) {
                    $currency = getCurrency($_SESSION['uid']);
                    $currency = $currency['id'];
                }

		$prices = array();
		$pid = $this->getPid();
		$result = full_query("
			SELECT optionname AS nodes, monthly AS price FROM tblproductconfigoptionssub, tblpricing
			WHERE tblpricing.relid = tblproductconfigoptionssub.id
			AND `type` = 'configoptions'
			AND tblpricing.currency = {$currency}
			AND configid = (
				SELECT id
				FROM tblproductconfigoptions
				WHERE optionname LIKE 'vpsnetNumNodes|%'
			)
			ORDER BY tblproductconfigoptionssub.optionname ASC
		");
                if($result){
                    while ($row = mysql_fetch_assoc($result)) {
                            $prices[(int) $row['nodes']] = sprintf("%01.2f", $row['price']);
                    }
                    ksort($prices);
                    return $prices;
                }
		return false;
	}

        public function getStorageNodePrices($curency=0) {

                if ($curency==0) {
                    $currency = getCurrency($_SESSION['uid']);
                    $currency = $currency['id'];
                }

		$prices = array();
		$pid = $this->getPid();
		$result = full_query("
			SELECT optionname AS nodes, monthly AS price FROM tblproductconfigoptionssub, tblpricing
			WHERE tblpricing.relid = tblproductconfigoptionssub.id
			AND `type` = 'configoptions'
			AND tblpricing.currency = {$currency}
			AND configid = (
				SELECT id
				FROM tblproductconfigoptions
				WHERE optionname LIKE 'vpsnetNumStorage|%'
			)
			ORDER BY tblproductconfigoptionssub.optionname ASC
		");
                if($result){
                    while ($row = mysql_fetch_assoc($result)) {
                            $prices[(int) $row['nodes']] = sprintf("%01.2f", $row['price']);
                    }
                    ksort($prices);
                    return $prices;
                }
                return false;
	}

        public function getRamNodePrices($curency=0) {

                if ($curency==0) {
                    $currency = getCurrency($_SESSION['uid']);
                    $currency = $currency['id'];
                }

		$prices = array();
		$pid = $this->getPid();
		$result = full_query("
			SELECT optionname AS nodes, monthly AS price FROM tblproductconfigoptionssub, tblpricing
			WHERE tblpricing.relid = tblproductconfigoptionssub.id
			AND `type` = 'configoptions'
			AND tblpricing.currency = {$currency}
			AND configid = (
				SELECT id
				FROM tblproductconfigoptions
				WHERE optionname LIKE 'vpsnetNumRam|%'
			)
			ORDER BY tblproductconfigoptionssub.optionname ASC
		");
                if($result){
                    while ($row = mysql_fetch_assoc($result)) {
                            $prices[(int) $row['nodes']] = sprintf("%01.2f", $row['price']);
                    }
                    ksort($prices);
                    return $prices;
                }
                return false;
	}


	/**
	 * Get a price for a given number of nodes
	 *
	 * @param int $nodes Number of nodes
	 * @return string Price (2 decimal places, no currency symbol)
	 */
	public function getCost($nodes) {
		$nodes = (int) $nodes;
		$prices = $this->getNodePrices();
		if (! isset($prices[$nodes])) {
			throw new Exception("Node price for request nodes not configured");
		}
		return sprintf("%01.2f", $prices[$nodes]);
	}
	
	/**
	 * Get product ID for vps.net server
	 *
	 * @return int Product ID
	 */
	public function getPid() {
		if(empty($this->pid)){
			$result = full_query("SELECT pid FROM tblproductconfiglinks WHERE 
				`gid` = (SELECT gid FROM `tblproductconfigoptions` WHERE optionname LIKE 'vpsnetNumNodes|%' LIMIT 1)");
			
			if (mysql_num_rows($result) == 0) {
				throw new Exception("VPS product ID is not set");
			}
			$data = mysql_fetch_assoc($result);
			$this->pid = (int) $data['pid'];
		}
		return (int) $this->pid;

	}
	
	public function getFreeNodes($consumerId,$type='vps') {
		$consumerId = (int) $consumerId;
		$count = 0;
		$nodes = $this->api()->getNodes($consumerId,$type);
                
		foreach ($nodes as $node) {
			if (is_null($node->virtual_machine_id)) {
				$count ++;
			}
		}
		return $count;
	}


       	public function getUsedNodes($consumerId,$type='vps') {

		$consumerId = (int) $consumerId;
		$count = 0;

        $count = 0;
		$nodes = $this->api()->getNodes($consumerId,$type);
                
		foreach ($nodes as $node) {
			if (!is_null($node->virtual_machine_id)) {
				$count ++;
			}
		}
		return $count;
	}

	
	
	public function getCloudName($cloudId) {
		$cloudId = (int) $cloudId;
		$this->populateClouds();
		foreach ($this->clouds as $cloud) {
			if($cloud->cloud->id == $cloudId) {
				return $cloud->cloud->label;
			}
		}
		throw new Exception("Unknown VPS cloud");
	}
	
	public function getTemplateName($cloudId, $templateId) {


                return $this->api()->getTemplateName($templateId);

                /*

		$templateId = (int) $templateId;
		$cloudId = (int) $cloudId;
		$this->populateClouds();
		foreach ($this->clouds as $cloud) {
			if($cloud->cloud->id == $cloudId) {
				foreach ($cloud->cloud->system_templates as $template) {
					if($template->id == $templateId) {
						return $template->label;
					}
				}
				throw new Exception("Unknown VPS template");
			}
		}
		throw new Exception("Unknown VPS cloud");
                */

	}
	
	private function populateClouds() {
		if($this->clouds === false) {
			$this->clouds = $this->api()->getAvailableCloudsAndTemplates();
		}
	}
	
	/**
	 * Grab an instance of the vpsnet API class
	 *
	 */
	private function getApiInstance() {
		//$result = full_query("
		//	SELECT count(*) FROM tblservers WHERE `type` = 'vpsnet'
		//");
		//if(mysql_num_rows($result) == 0) {
		//	throw new Exception("No vps server config found");
		//}
                $result = full_query("
			SELECT * FROM tbladdonmodules WHERE `module` = 'vpsnet'
		");
		while($data = mysql_fetch_assoc($result)){                   
            if($data['setting'] == 'vpsusername'){
                $vpsusername = $data['value'];
            }
            if($data['setting'] == 'vpsapikey'){
                $vpsapikey = $data['value'];
            }
        }
		require_once(realpath(dirname(__FILE__))."/vpsnet-api.php");
		$this->vpsNetApi = VPSNET::getInstance($vpsusername, $vpsapikey);
	}

	function getVM($id) {
		require_once(realpath(dirname(__FILE__))."/vpsnet-api.php");
		$vm = new VirtualMachine();
		$vm->id = $id;
		return $vm;
	}

}



class WHMCSUser {

      function WHMCSUser($id) {

          $this->id=$id;

          
          $this->restrict = array();


          $q="select area,access from vpsnet_restrict where id=".(int)$this->id;

          $result=full_query($q);

          while ($check = mysql_fetch_assoc($result)) {

              if ($check['area'])
                $this->restrict[$check['area']]=1;

          }


      }

      function resetAccess() {

            full_query("delete from  vpsnet_restrict where id='".(int)$this->id."'");

      }

      function setAccess($area,$access) {

        if ($access) {

            full_query("insert into vpsnet_restrict (id,area,access) values (".(int)$this->id.",'".$area."',1)");

        } else {

            full_query("delete from  vpsnet_restrict where id=".(int)$this->id." and area='".$area."',1)");

        }

      }
}
