<?php
require_once("class.php");
require_once("functions.php");
//error_reporting(E_ALL & ~E_NOTICE);
//ini_set('display_errors', 1);

function vpsnet_ConfigOptions() {
    $vps = new vps();
    $templ = $vps->api()->getAvailableCloudsAndTemplates();
    $options[] = '';
    foreach ($templ as $cloud) {
        foreach ($cloud->cloud->system_templates as $templ) {
            if(!$cloud->cloud->fusion_io)
                $options[] = $cloud->cloud->id . '+' . $templ->id . '|' . $cloud->cloud->label . ' ' . $templ->label;
        }
    }
    $configarray = array(
        "VPS Nodes" => array("Type" => "text", "Size" => "5",),
        "Storage Nodes" => array("Type" => "text", "Size" => "5"),
        "RAM nodes" => array("Type" => "text", "Size" => "5"),
        "Cloud/Template" => array("Type" => "dropdown", "Options" => implode(',', $options)),
        "Snapshots" => array("Type" => "yesno", "Description" => "Tick to grant access"),
        "R1Soft" => array("Type" => "yesno", "Description" => "Tick to grant access"),
        "Rsync" => array("Type" => "yesno", "Description" => "Tick to grant access"),
        "Panel" => array("Type" => "dropdown", "Options" => "None,cPanel,ISPmanager"),
        "Softaculous" => array("Type" => "yesno", "Description" => "Tick to grant access"),
        "Rvskin" => array("Type" => "yesno", "Description" => "Tick to grant access"),
        "Litespeed" => array("Type" => "yesno", "Description" => "Tick to grant access"),
        "WHMCS" => array("Type" => "yesno", "Description" => "Tick to grant access"),
		"Power Pack" => array("Type" => "yesno", "Description" => "Tick to grant access"),
		"Server Density" => array("Type" => "yesno", "Description" => "Tick to grant access"),
		"Auto Scaling" => array("Type" => "yesno", "Description" => "Tick to grant access"),
    );

    return $configarray;
}

function vpsnet_CreateAccount($params){

      
    if ($params['action'] == 'create') {
        $vps = new vps();
        $serviceId = (int) $params['serviceid'];

        if (isset($params['configoptions']['vpsnetNumNodes']) && $params['configoptions']['vpsnetNumNodes'] > 0) {
            //Get the inital number of nodes
            $initialNodes = (int) $params['configoptions']['vpsnetNumNodes'];
            $initialStorageNodes = (int) $params['configoptions']['vpsnetNumStorage'];
            $initialRamNodes = (int) $params['configoptions']['vpsnetNumRam'];

            //Add the nodes to the account and tag with the ID of the consumer
            if ($vps->api()->addNodes($initialNodes, $serviceId)) {

                $vps->api()->addNodes($initialStorageNodes, $serviceId, 'storage');

                $vps->api()->addNodes($initialRamNodes, $serviceId, 'ram');

                return "success";
            } else {
                return "Error Adding Nodes.";
            }
        } else {
            $label = $params['domain'];
            $hostname = $params['domain'];
            //create vps from vps_cloud.php bash//
			if (isset($params['configoptions']['vpsnetNumNodesb']) && $params['configoptions']['vpsnetNumNodesb'] > 0)
			{
			   $nodes = intval($params['configoptions']['vpsnetNumNodesb']); //regular nodes
               $storagenodes = (int) $params['configoptions']['vpsnetNumStorageb']; //storage nodes
               $ramnodes = (int) $params['configoptions']['vpsnetNumRamb']; //ram nodes
			}
			else 
			{
			//create vps from vps_cloud.php//
               $nodes = intval($params['configoption1']); //regular nodes
               $storagenodes = intval($params['configoption2']); //storage nodes
               $ramnodes = intval($params['configoption3']); //ram nodes
			}
			
            if(!empty($params['configoption4'])){
                $cltpm = explode('|', $params['configoption4']); //cloud+template
                $cltmpl = explode('+', $cltpm[0]); // [0] = cloud_id, [1] = template_id
                $cloud_id = $cltmpl[0];
                $template_id = $cltmpl[1];
            }elseif(is_array($params['configoptions'])){  
                $template_id = $params['configoptions']['template_id'];
                $cloud_id = $params['configoptions']['cloud_id'];
            }
            



            $iswinq = full_query("SELECT COUNT(*) as n FROM tblproductconfigoptionssub WHERE optionname LIKE '{$template_id}|%' AND optionname LIKE '%Windows%'");
            $iswin = mysql_fetch_assoc($iswinq);

            $snapshots = isset($params['configoptions']['snapshot']) ? (int)$params['configoptions']['snapshot'] : (!empty($params['configoption5']) ? 1 : 0); //snapshots
            $r1soft = isset($params['configoptions']['r1soft']) ? (int)$params['configoptions']['r1soft'] : (!empty($params['configoption6']) ? 1 : 0); //r1soft
            $rsync = isset($params['configoptions']['rsync']) ? (int)$params['configoptions']['rsync'] : (!empty($params['configoption7']) ? 1 : 0); //rsync
             $autoscaling = isset($params['configoptions']['autoscaling']) ? (int)$params['configoptions']['autoscaling'] : (!empty($params['configoption15']) ? 1 : 0); //autoscaling
			
			 			 
			if (isset($params['configoptions']['vpsnetNumNodesb']) && $params['configoptions']['vpsnetNumNodesb'] > 0)
			{
			    if($snapshots > 1)
			       $snapshots = 1;
				if($r1soft > 1)
			       $r1soft = 1;
				if($rsync > 1)
			       $rsync = 1;       
		    }		   
			
						

            $consumer = $params['serviceid'];
			if (isset($params['configoptions']['vpsnetNumNodesb']) && $params['configoptions']['vpsnetNumNodesb'] > 0)
			{
			    $clientId       = $params["clientsdetails"]['userid'];
				$cloud_nod_pid   = $vps->getPid();
				$result = select_query("tblhosting", "id", "packageid = {$cloud_nod_pid} and userid = {$clientId}");
				if(!$result) return 0;
				if(mysql_num_rows($result) == 0) {
					return 0;
				}
				$data = mysql_fetch_assoc($result);
				$consumer = (int) $data['id']; 
			}		
					
          
            if(isset($params['configoptions']['panel'])){
                $licence = array(
                    '1' => $params['configoptions']['panel'] === 'cpanel' ? 1 : 0,
                    '2' => $params['configoptions']['panel'] === 'cpanel' && $params['configoptions']['softaculous'] > 0 ? 1 : 0,
                    '3' => $params['configoptions']['panel'] === 'cpanel' && $params['configoptions']['rvskin'] > 0 ? 1 : 0,
                    '4' => $params['configoptions']['litespeed'] === '1' ? 1 : 0,
                    '6' => $params['configoptions']['panel'] === 'ispmanager' ? 1 : 0,
                    '8' => $params['configoptions']['whmcs'] === '1' ? 1 : 0,
					//server density 5
					'11' => $params['configoptions']['powerpack'] === '1' ? 1 : 0,
					'5' => $params['configoptions']['serverdensity'] === '1' ? 1 : 0
					//powerpack 11
                );
            }else{
                $licence = array(
                    '1' => $params['configoption8'] == 'cPanel' ? 1 : 0,
                    '2' => $params['configoption8'] == 'cPanel' && $params['configoption9'] == 'on' ? 1 : 0,
                    '3' => $params['configoption8'] == 'cPanel' && $params['configoption10'] == 'on' ? 1 : 0,
                    '4' => $params['configoption11'] == 'on' ? 1 : 0,
                    '6' => $params['configoption8'] == 'ISPmanager' ? 1 : 0,
                    '8' => $params['configoption12'] == 'on' ? 1 : 0,
                    '11' => $params['configoption14'] == 'on' || $params['configoptions']['powerpack'] ==1 ? 1 : 0,
					'5' => $params['configoption13'] == 'on' || $params['configoptions']['serverdensity'] ==1 ? 1 : 0
                );
            }
			
			
             //code bash
			//check vps created from cloud nodes
			//no new addnode  call
			if (isset($params['configoptions']['vpsnetNumNodesb']) && $params['configoptions']['vpsnetNumNodesb'] > 0)
			{
			     $freeNodes_vps = $vps->getFreeNodes($consumer, 'vps'); 
				 if($freeNodes_vps < $nodes){
					 return "error : no free vps nodes.";
				 }	
				 
				 $freeNodes_storage = $vps->getFreeNodes($consumer, 'storage'); 
				 if($freeNodes_storage < $storagenodes){
					 return "error : no free storage nodes.";
				 }	
				 
				 $freeNodes_ram = $vps->getFreeNodes($consumer, 'ram'); 
				 if($freeNodes_ram < $ramnodes){
					 return "error : no free RAM nodes.";
				 }		  			  			    
			}
			//end bash
			
			else
			{ 
				$cnodes_vps = $vps->api()->getNodes($consumer, 'vps');            
				foreach ($cnodes_vps as $node) {
					if($node->virtual_machine_id == 0 && $node->consumer_id == 0){
						$freeNodes_vps[] = $node;
					}
				}
				if(count($freeNodes_vps) < $nodes){
					 $vps->api()->addNodes($nodes - count($freeNodes_vps), $consumer, 'vps');
				}
	
				if($storagenodes > 0){
					$cnodes_storage =  $vps->api()->getNodes($consumer, 'storage');
					foreach ($cnodes_storage as $node) {
						if($node->virtual_machine_id == 0 && $node->consumer_id == 0){
							$freeNodes_storage[] = $node;
						}
					}
					if(count($freeNodes_storage) < $storagenodes){
					   $vps->api()->addNodes($storagenodes - count($freeNodes_storage), $consumer, 'storage');
					}
				}
					
	
				if($ramnodes > 0){
					$cnodes_ram =  $vps->api()->getNodes($consumer, 'ram');
					foreach ($cnodes_ram as $node) {
						if($node->virtual_machine_id == 0 && $node->consumer_id == 0){
							$freeNodes_ram[] = $node;
						}
					}
					if(count($freeNodes_ram) < $ramnodes){
						$vps->api()->addNodes($ramnodes - count($freeNodes_ram), $consumer, 'storage');
					}
				}
            }
			
			
            $new_vm = new VirtualMachine($label, $hostname, $nodes, $snapshots, $rsync, $r1soft, $cloud_id, $template_id, $consumer, $licence, $storagenodes, $ramnodes,$autoscaling);
            
			          
			
            try{
                $newvps = $vps->api()->createVirtualMachine($new_vm);
            }catch(Exception $e){
                return $e->getMessage();
            }    
            $ser = array(
                'username' => $iswin['n'] > 0 ? 'Administrator' : 'root',
                'dedicatedip' => $newvps->virtual_machine->primary_ip_address->ip_address->ip_address,
                'password' => encrypt($newvps->virtual_machine->password)
                );
            update_query("tblhosting",$ser,array("id" => $params['serviceid']));
            
            $result = select_query('tblcustomfields', 'id', array('fieldname' => 'server_id', 'relid' => $params['pid']));
            $data = mysql_fetch_assoc($result);
            if ($data) {
                $fid = $data['id'];
                update_query("tblcustomfieldsvalues",array("value" => $newvps->virtual_machine->id),array("fieldid" => $fid, "relid" => $params['serviceid']));
            } else {
                $array = array("relid" => $params['pid'], "type" => 'product', "fieldname" => 'server_id', 'fieldtype' => 'text', 'adminonly' => 'on');
                $newid = insert_query("tblcustomfields", $array);
                $fid = mysql_insert_id();
                insert_query("tblcustomfieldsvalues",array("value" => $newvps->virtual_machine->id, "fieldid" => $fid, "relid" => $params['serviceid']));
            }
			
			//change productid t0 -1 for server created from cloudnodes
			// by bash
			if (isset($params['configoptions']['vpsnetNumNodesb']) && $params['configoptions']['vpsnetNumNodesb'] > 0)
			{
			    mysql_query("update tblhostingconfigoptions set qty = 1 where relid = ".$params['serviceid']." and qty > 1");
				 
				 $messagename = 'New Cloud Server Information';
   
                         $extravars = array( 
                        'service_dedicated_ip' => $newvps->virtual_machine->primary_ip_address->ip_address->ip_address, 
                        'service_password' => $newvps->virtual_machine->password,
                        'service_assigned_ips' => $newvps->virtual_machine->primary_ip_address->ip_address->ip_address,
                        'service_domain' => $newvps->virtual_machine->hostname . '.' . $newvps->virtual_machine->domain_name
                        );
                sendMessage($messagename,$consumer,$extravars);
			   // update_query("tblhosting",array('packageid' => -1),array("id" => $params['serviceid']));
			}
			
            return "success";
        }
		
		
    }
}

function vpsnet_TerminateAccount($params) {
    $vars = get_module_vars();
    if($params['action'] == 'terminate'){
        $vps = new vps();
        $serviceId = (int) $params['serviceid'];

        if (isset($params['configoptions']['vpsnetNumNodes'])) {

            //Delete all VMs
            $vms = $vps->api()->getVirtualMachines($serviceId);
            foreach ($vms as $vm) {
                $vm->remove();
            }

            //Delete all Nodes
            $nodes = $vps->api()->getNodes($serviceId);
            foreach ($nodes as $node) {
                if($vars['deletenodes'] == 'on')
                    $node->remove();
                else
                    $node->update(0);
            }
            $nodes = $vps->api()->getNodes($serviceId, 'storage');
            foreach ($nodes as $node) {
                if($vars['deletenodes'] == 'on')
                    $node->remove();
                else
                    $node->update(0);
            }

            $nodes = $vps->api()->getNodes($serviceId, 'ram');
            foreach ($nodes as $node) {
                if($vars['deletenodes'] == 'on')
                    $node->remove();
                else
                    $node->update(0);
            }

            return "success";
        }else{
            if(isset($params['customfields']['server_id']) && !empty($params['customfields']['server_id'])){
                $vm = new VirtualMachine();
                $vm->id = $params['customfields']['server_id'];
                $vm->loadFully();
                $vm->remove();
                $nodes = $vps->api()->getNodes($vm->consumer_id);
                foreach ($nodes as $node) {
                    if($vars['deletenodes'] == 'on')
                        $node->remove();
                    else
                        $node->update(0);
                }
                $nodes = $vps->api()->getNodes($vm->consumer_id, 'storage');
                foreach ($nodes as $node) {
                   if($vars['deletenodes'] == 'on')
                        $node->remove();
                    else
                        $node->update(0);
                }
                $nodes = $vps->api()->getNodes($vm->consumer_id, 'ram');
                foreach ($nodes as $node) {
                    if($vars['deletenodes'] == 'on')
                        $node->remove();
                    else
                        $node->update(0);
                }
                $ser = array(
                    "username" => '',
                    'dedicatedip' => '',
                    'password' => ''
                    );
                update_query("tblhosting",$ser,array("id" => $params['serviceid']));
                $result = select_query('tblcustomfields', 'id', array('fieldname' => 'server_id', 'relid' => $params['pid']));
                $data = mysql_fetch_assoc($result);
                update_query("tblcustomfieldsvalues",array("value" => ''), array("fieldid" => $data['id'], "relid" => $params['serviceid']));
            }
            return "success";
        }
    }
}

function vpsnet_SuspendAccount($params) {

    $vps = new vps();

    if(isset($params['configoptions']['vpsnetNumNodes'])){
        $serviceId = (int) $params['serviceid'];
        $vms = $vps->api()->getVirtualMachines($serviceId);
        foreach ($vms as $vm) {
            $vm->loadFully();
            if ($vm->running) {
                $vm->shutdown();
                mysql_query("INSERT INTO vpsnet_vps (id,user_id,status) VALUES ('{$vm->id}','{$params['clientsdetails']['userid']}','0')
                ON DUPLICATE KEY UPDATE `status`='0';");
            }
        }
    }else{
        $id = $params['customfields']['server_id'];
        $vm = $vps->getVM($id);
        $vm->id = $id;
        $vm->loadFully();
        if($vm->running)
            $vm->shutdown();
        
        mysql_query("INSERT INTO vpsnet_vps (id,user_id,status) VALUES ('{$id}','{$params['clientsdetails']['userid']}','0')
        ON DUPLICATE KEY UPDATE `status`='0';");
    }
    return "success";
}

/**
 * This is function vpsnet_UnsuspendAccount
 *
 * @param mixed $params Params from WHMCS
 * @return string "success" or "Error string"
 *
 */
function vpsnet_UnsuspendAccount($params) {
    $vps = new vps();
    if(isset($params['configoptions']['vpsnetNumNodes'])){
        $serviceId = (int) $params['serviceid'];
        $vms = $vps->api()->getVirtualMachines($serviceId);
        foreach ($vms as $vm) {
            $vm->loadFully();
            if (!$vm->running) {
                $vm->powerOn();
                mysql_query("INSERT INTO vpsnet_vps (id,user_id,status) VALUES ('{$vm->id}','{$params['clientsdetails']['userid']}','1')
                ON DUPLICATE KEY UPDATE `status`='1';");
            }
        }
    }else{
        $id = $params['customfields']['server_id'];
        $vm = $vps->getVM($id);
        $vm->id = $id;
        $vm->loadFully();
        if(!$vm->running)
          $vm->powerOn();
        mysql_query("INSERT INTO vpsnet_vps (id,user_id,status) VALUES ('{$id}','{$params['clientsdetails']['userid']}','1')
        ON DUPLICATE KEY UPDATE `status`='1';");
    }
    return "success";
}

function upgradeNodes($serviceId, $newNodes, $type = 'vps') {

    $vps = new vps();

    $nodes = $vps->api()->getNodes($serviceId, $type);

    $nodeCount = count($nodes);
    $used = 0;
    if ($nodeCount > $newNodes) {
        //Remove Nodes
        //Check that there are free nodes, and take note of their id's
        $freeNodes = array();

        foreach ($nodes as $nodeKey => $node) {
            if (is_null($node->virtual_machine_id)) {
                $freeNodes[] = $nodeKey;
            } else {
                $used++;
            }
        }
        $freeNodes = array_slice($freeNodes, $newNodes, $nodeCount - $newNodes);

        if ($used > $newNodes) {
            return "Error There are not enough free nodes to downgrade this account.";
        } else {
            foreach ($freeNodes as $freeNode) {
                if($vars['deletenodes'] == 'on')
                    $nodes[$freeNode]->remove();
                else
                    $nodes[$freeNode]->update(0);
                
            }
        }

        return true;
    } elseif ($nodeCount < $newNodes) {

        $addCount = $newNodes - $nodeCount;

        //Adding node
        if ($vps->api()->addNodes($addCount, $serviceId, $type)) {
            return "success";
        } else {
            return "Error altering account, couldn't add nodes.";
        }
    } else {
        return true;
    }
}

function vpsnet_ChangePackage($params) {
    $serviceId = (int) $params['serviceid'];

 

    if(isset($params['configoptions']['vpsnetNumNodes'])){
        $newNodes = (int) $params['configoptions']['vpsnetNumNodes'];

        $newStorageNodes = (int) $params['configoptions']['vpsnetNumStorage'];

        $newRamNodes = (int) $params['configoptions']['vpsnetNumRam'];

        $n1 = upgradeNodes($serviceId, $newNodes, $type = 'vps');
        if ($n1 != "success")
            return $n1;

        $n2 = upgradeNodes($serviceId, $newStorageNodes, $type = 'storage');
        if ($n2 != "success")
            return $n2;

        $n3 = upgradeNodes($serviceId, $newRamNodes, $type = 'ram');
        if ($n3 != "success")
            return $n3;
    }
	
	else{
        return editvm($params);
    }
	
    return "success";
}


function editvm($params){

 
    $vps = new vps();
    $id = $params['customfields']['server_id'];
    $vm = $vps->getVM($id);
    $vm->id = $id;
    $vm->loadFully();
	
	$vm_licenses = $vm->loadLicenses();
	$cur_snap_shot = $vm->backups_enabled;
	if($vm_licenses['rsync_license']){$cur_rsync = 1;}else{$cur_rsync = 0;}
	if($vm_licenses['r1soft_license']){$cur_r1soft = 1;}else{$cur_r1soft = 0;}
	
    $vm->backups_enabled = (int) $params['configoptions']['snapshot'];
    $vm->rsync_backups_enabled = (int) $params['configoptions']['rsync'];
    $vm->r1_soft_backups_enabled = (int) $params['configoptions']['r1soft'];
    $vm->licence = NULL;
	
		
	$vm->consumer_id = $params['serviceid'];
	if(isset($params['configoptions']['vpsnetNumNodesb']))
	{
	            $original_servie_id = $params['serviceid'];
				$vm->slices_required = (int) $params['configoptions']['vpsnetNumNodesb'];
				$vm->storage_nodes_required = (int) $params['configoptions']['vpsnetNumStorageb'];
				$vm->ram_nodes_required = (int) $params['configoptions']['vpsnetNumRamb'];
				
				$clientId        = $params["clientsdetails"]['userid'];
				$cloud_nod_pid   = $vps->getPid();
				$result = select_query("tblhosting", "id", "packageid = {$cloud_nod_pid} and userid = {$clientId}");
				if(!$result) return 0;
				if(mysql_num_rows($result) == 0) {
					return 0;
				}
				$data = mysql_fetch_assoc($result);
				$vm->consumer_id = (int) $data['id']; 
				
			   				   
		 //convert package id to -1 to vps product id
		 
		// mysql_query("update `tblhosting` set `packageid` = -1 WHERE `id` = ".$original_servie_id);		      
		    	
	}
                if($vm->backups_enabled > 1)
			       $vm->backups_enabled = 1;
				if($vm->rsync_backups_enabled > 1)
			       $vm->rsync_backups_enabled = 1;
				if($vm->r1_soft_backups_enabled > 1)
			       $vm->r1_soft_backups_enabled = 1;  
	 
	
    $template_id = $params['configoptions']['template_id'];
    $vm->licence = array(
        '1' => $params['configoptions']['panel'] == 'cpanel' ? 1 : 0,
        '2' => $params['configoptions']['panel'] == 'cpanel' && $params['configoptions']['softaculous'] ? 1 : 0,
        '3' => $params['configoptions']['panel'] == 'cpanel' && $params['configoptions']['rvskin'] ? 1 : 0,
        '4' => $params['configoptions']['litespeed'],
        '6' => $params['configoptions']['panel'] == 'isp manager' ? 1 : 0,
        '8' => $params['configoptions']['whmcs'],
        '9' => $params['configoptions']['hostbill'],
		'11' => $params['configoptions']['powerpack'],
		'5' => $params['configoptions']['serverdensity']
    );
	
	//code bash 
	//hidden config option in semi pre-configured
	$product_id = $params['pid'];
	  //hidden config option id id
	$config_sql = mysql_query("select a.optionname as hiden_option from tblproductconfigoptions a join tblproductconfiglinks b on a.gid = b.gid where a.hidden =1 and b.pid = ".$product_id);
	while($config_row = mysql_fetch_array($config_sql))
	{
	  $hidden_config = $config_row['hiden_option'];
	  if($hidden_config =='snapshot|Snapshot Backup') {$vm->backups_enabled = $cur_snap_shot;}
	  if($hidden_config =='rsync|RSync Backup') {$vm->rsync_backups_enabled = $cur_rsync;}
	  if($hidden_config =='r1soft|R1Soft Backup') {$vm->r1_soft_backups_enabled = $cur_r1soft;}
	}
	//end hidden config option

    try{
        $vm->update();
    }catch(Exception $e){
        logActivity($e->getMessage());
    }
    if($vm->system_template_id != $template_id){
        try{
            $vm->reinstall((int) $template_id);
        }catch(Exception $e){
            logActivity($e->getMessage());
            return $e->getMessage();
        }
    }
	if(isset($params['configoptions']['vpsnetNumNodesb']))
	{
	  mysql_query("update tblhostingconfigoptions set qty = 1 where relid = ".$params['serviceid']." and qty > 1");
    }
    return 'success';
}


function vpsnet_ClientAreaCustomButtonArray($params) {
    global $_LANG;
    $buttonarray = array($_LANG['vpsnetManageVPS'] => "gotomanagevps");
    return $buttonarray;
}
function  vpsnet_gotomanagevps($params){
    global $CONFIG, $_LANG;
    
    if(!empty($params['customfields']['server_id'])){
	    //product id vps from cloud nodes
		$vpsPid = getPID_vpsnet();
		$package_id = $params['packageid'];
		 if($package_id != $vpsPid)
		 {
		   $bnutt = $CONFIG['SystemURL'].'/vps-cloud.php?m=overview&id=' . $params['customfields']['server_id'] . '&st';
		 }
		 else
		 {
		   $bnutt = $CONFIG['SystemURL'].'/vps-cloud.php?m=overview&id=' . $params['customfields']['server_id'];
		 }  
		        
    }elseif(isset($params['configoptions']['vpsnetNumNodes'])){
        $vps = new vps();
        $vms = $vps->api()->getVirtualMachines($params['serviceid'], false);
        if(count($vms) > 0)
            $bnutt =  $CONFIG['SystemURL'].'/vps-cloud.php';
        else
            $bnutt =  $CONFIG['SystemURL'].'/vps-cloud.php?m=create';
        
    }
    
    header('Location: '.$bnutt);
}

function vpsnet_ClientArea($params) {
    global $CONFIG, $_LANG;
    if(!empty($params['customfields']['server_id'])){
        $bnutt = '<a class="btn info" href="'.$CONFIG['SystemURL'].'/vps-cloud.php?m=overview&id=' . $params['customfields']['server_id'] . '&st">'.$_LANG['vpsnetManageVPS'].'</a>';
    }elseif(isset($params['configoptions']['vpsnetNumNodes'])){
        $vps = new vps();
        $vms = $vps->api()->getVirtualMachines($params['serviceid'], false);
        if(count($vms) > 0)
            $bnutt =  '<a class="btn info" href="'.$CONFIG['SystemURL'].'/vps-cloud.php">'.$_LANG['vpsnetManageVPSs'].'</a>';
        else
            $bnutt =  '<a class="btn info" href="'.$CONFIG['SystemURL'].'/vps-cloud.php?m=create">'.$_LANG['vpsnetCreateVPSs'].'</a>';
        
    }
    return $bnutt;
}

function vpsnet_LoginLink($params){
    return $bnutt;
}

function vpsnet_AdminServicesTabFields($params) {
    $admindir = dirname($_SERVER['SCRIPT_NAME']);
    $modulelink = $admindir .'/addonmodules.php?module=vpsnet';
    $modurl = $_SERVER['SCRIPT_NAME']."?userid={$params['clientsdetails']['userid']}&id={$params['serviceid']}&modop=custom&ac=";
    $uid = $params['clientsdetails']['userid'];
    $vps = new vps();
    $vms = $vps->api()->getVirtualMachines($params['serviceid'], false);
    $dbvmRes = select_query("vpsnet_vps", '*');
    while ($data = mysql_fetch_assoc($dbvmRes)) {
       $dbvms[$data['id']] = $data;
    }
    $tableout = '
    <table class="datatable" width="100%" border="0" cellspacing="1" cellpadding="3">
        <tr>
            <th>ID</th>
            <th>Label</th>
            <th>IP</th>
            <th>Backups</th>
            <th>CP</th>
            <th>Password</th>
            <th>Actions</th>
        </tr>';
    foreach ($vms as $vm) {
        $dbvm = $dbvms[$vm->id];
        $tableout .= '
            <tr>
                <td>' . $vm->id . '</td>
                <td>' . $vm->label . '</td>
                <td style="text-align:center;"> ' . $vm->primary_ip_address->ip_address->ip_address . '</td>
                <td style="text-align:center;">' . ($vm->backups_enabled ? 'Enabled' : 'Disabled') . '</td>
                <td>' . ucwords($vm->getCpanel()) . '</td>
                <td>' . $vm->password . '</td>
                <td style="text-align:center;">
                    <button type="button" class="btn btn-mini" onclick="window.location=\'' . $modulelink . '&userid=' . $uid . '&m=access\'" title="Restrict access"><img src="images/icons/restrict-access.png" border="0" align="absmiddle" alt="Restrict access " title="Restrict access "></button>
                    ' . ($dbvm['status'] !== '0' ? 
                        ' <button type="button" class="btn btn-mini" onclick="window.location=\'' . $modulelink . '&userid=' . $uid . '&m=suspend&vps=' . $vm->id . '\'" title="Suspend VPS"><img src="images/icons/accessdenied.png" border="0" align="absmiddle" alt="Suspend VPS" title="Suspend VPS"></button>' : 
                        ' <button type="button" class="btn btn-mini" onclick="window.location=\'' . $modulelink . '&userid=' . $uid . '&m=unsuspend&vps=' . $vm->id . '\'" title="Unsuspend VPS"><img src="images/icons/tick.png" border="0" align="absmiddle" alt="Unsuspend VPS" title="Ususpend VPS"></button>') . '
                    <button type="button" class="btn btn-mini" onclick="window.location=\''.$modulelink.'&userid=' . $uid . '&m=shutdownvm&vps=' . $vm->id.'\'">Shutdown</button>
                    <button type="button" class="btn btn-mini" onclick="window.location=\''.$modulelink.'&userid=' . $uid . '&m=startvm&vps=' . $vm->id.'\'">Start</button>
                    <button type="button" class="btn btn-mini" onclick="window.location=\''.$modulelink.'&userid=' . $uid . '&m=rebootvm&vps=' . $vm->id.'\'">Reboot</button>                    
                </td>
           </tr>
        ';
    }
    $tableout .= '</table>';
    $fieldsarray = array(
     'Cloud Servers' => '<div class="tablebg">'.$tableout.'</div>',
    );
    return $fieldsarray;
}
function  vpsnet_shutdown_vm($params){
    $vps = new vps();
    $vm = $vps->getVM($_GET['vmid']);
    $vm->loadFully();
    if($vm->running)
      $vm->powerOff();
    $result = "success";
    return $result;
}
function  vpsnet_start_vm($params){
    $vps = new vps();

    $vm = $vps->getVM($_GET['vmid']);
    $vm->loadFully();
    if(!$vm->running)
      $vm->powerOn();

    $result = "success";
    return $result;
}
function  vpsnet_reboot_vm($params){
    $vps = new vps();
    try{
        $vps->getVM($_GET['vmid'])->reboot();
    }catch(Exception $e){
        return $e->getMessage();
    }
    $result = "success";
    return $result;
}


?>
