<?php

/**
 * This page is used to display a speciffic cart.
 * This populates the session vars and then passes into a later step in
 * the purchase process for whmcs
 *
 * Reads the values for max nodes from the configured values for the system.
 *
 * */
//Whmcs Includes
define("CLIENTAREA", true);
if($_SERVER['HTTPS'] || defined( "FORCESSL" ))
    $in_ssl = true;

if(file_exists("dbconnect.php")){
    //versions before 5.2
    require_once("dbconnect.php");
    require_once("includes/functions.php");
}else{
    //5.2 and higher
    require_once("init.php");
}

require_once("modules/servers/vpsnet/functions.php");
require_once("modules/servers/vpsnet/class.php");
$vps = new vps();
$sysurl = !empty($CONFIG['SystemSSLURL']) ? $CONFIG['SystemSSLURL'] : $CONFIG['SystemURL'];

//check if the client already has vpsnet service - if they do redirect them to node management

try {
    $service = $vps->getServiceId();
} catch (Exception $ex) {
    if ($ex->getMessage() == "VPS product ID is not set") {
        echo '<html>';
        echo '<body><h1>' . "Please check if product 'Cloud nodes' and Configurable Option Group 'Cloud hosting' exist and linked." . '</h1></body>';
        echo '</html>';
        die();
    }
}

$serviceData = localApi('getclientsproducts', array('clientid'=> $_SESSION['uid'], 'serviceid'=> $service));

if($service > 0 && (is_array($serviceData['products']) && $serviceData['products']['product'][0]['Status'] != 'Active')){
    header("Location: $sysurl/vps-cloud.php");
    die();
}
if ($service > 0) {
    header("Location: $sysurl/upgrade.php?id={$service}&type=configoptions");
    die();
}
//Read the PID for the VPSNet Service
$pid = $vps->getPid();

switch ($action) {
    case 'updateCart':
        //Create the cart values
        //Get the config id for the number of nodes config
        $numNodeId = $vps->getNodesConfigOptionId(intval($_POST['num-nodes']), intval($_POST['storage-num-nodes']), intval($_POST['ram-num-nodes']));
        //Create the cart
        $_SESSION["cart"]["products"][] = array(
            "pid" => $pid,
            'billingcycle' => 'monthly',
            'domain' => "",
            'configoptions' => $numNodeId
        );
        //Redirect to the cart
        header("Location: $sysurl/cart.php?a=view");
        exit();
        break;
}
//Whmcs Includes
require_once("includes/clientareafunctions.php");
require_once("includes/configoptionsfunctions.php");
//Get Node Costs
//print_r(getCurency());
$nodePriceScript = array();
$nodeCosts = $vps->getNodePrices();

if ($nodeCosts)
    foreach ($nodeCosts as $i => $cost) {
        $nodePriceScript[$i] = $cost;
    }

$maxAssignableNodes = count($nodeCosts);

$nodeStoragePriceScript = array();
$nodeStorageCosts = $vps->getStorageNodePrices();
if ($nodeStorageCosts)
    foreach ($nodeStorageCosts as $i => $cost) {
        $nodeStoragePriceScript[$i] = $cost;
    }

$maxAssignableStorageNodes = count($nodeStorageCosts) - 1;

$nodeRamPriceScript = array();
$nodeRamCosts = $vps->getRamNodePrices();

if ($nodeRamCosts)
    foreach ($nodeRamCosts as $i => $cost) {
        $nodeRamPriceScript[$i] = $cost;
    }

$maxAssignableRamNodes = count($nodeRamCosts)  - 1;

//Init the templaet
$pagetitle = "Node Cart";
$pageicon = "images/support/clientarea.gif";
$breadcrumbnav = '<a href="index.php">' . $_LANG['globalsystemname'] . '</a>';
$breadcrumbnav .= ' > <a href="nodecart.php">Node Cart</a>';
initialiseClientArea($pagetitle, $pageicon, $breadcrumbnav);
$smartyvalues['minShownNodes'] = 1;
$smartyvalues['minAssignableNodes'] = 0;

$smartyvalues['nodeCostRegular'] = $nodePriceScript;
$smartyvalues['nodeCostStorage'] = $nodeStoragePriceScript;
$smartyvalues['nodeCostRam'] = $nodeRamPriceScript;

$smartyvalues['maxAssignableNodes'] = $maxAssignableNodes;
$smartyvalues['maxAssignableStorageNodes'] = $maxAssignableStorageNodes;
$smartyvalues['maxAssignableRamNodes'] = $maxAssignableRamNodes;

$smartyvalues['defaultNodes'] = '1';
$smartyvalues['defaultStorageNodes'] = '0';
$smartyvalues['defaultRamNodes'] = '0';
$smartyvalues['currency'] = getCurrency($_SESSION['uid']);
$smartyvalues['sysurl'] = $sysurl;

//print_r($smartyvalues['currency']);


$templatefile = "vps/nodecart";
$tsheme = $CONFIG['Template'];
$tpath = dirname(__FILE__) . '/templates';
if (is_file($tpath . '/' . $tsheme . '/' . $templatefile . '.tpl')) {
    outputClientArea($templatefile);
} else {
    $from = $tpath . '/default/vps';
    $to = $tpath . '/' . $tsheme . '/vps';
    echo '<html>';
    echo '<body><h1>' . "Please copy (symlink) templates from $from to $to" . '</h1></body>';
    echo '</html>';
}
?>
