<!-- ISP manager Start-->
<div title="ISP Manager installation" id="show-ispmanager" style="display:none">
<div>
<div id="cpanel_help" title="ISPmanager Install">

Once you receive confirmation that your license is set, ssh to your server and execute the following commands<br>

<pre>
wget "http://download.ispsystem.com/install.sh"
sh install.sh
</pre>

If during the install you get this message "system needs reboot - reason selinux is disabled on this server", and the server reboots, please re-initiate the install process after the reboot, ISPmanager Pro is not yet installed by then.<br><br>

The install script is virtually hand-free, so just sit back and wait until it's done, after that you can login to the Admin interface by visiting https://your.ip.number/manager/, username: root, password: your root password<br><br>

Documentation is available <a href="https://ispsystem.com/en/software/ispmanager/documentation/">HERE</a><br><br>


<b>Attention for Ubuntu users:</b><br><br>

Follow the instructions below to get mail.<br><br>

It should be noted that the default installation options will result with a failure for webmail, smtp, or dovecot.<br><br>

Heres a step by step walkthrough to get it working:<br><br>

<ul>
    <li> Create your vps with Ubuntu 8.04 LTS 64-bit Basic Installation</li>
    <li> Once created it's most likely best to update so run:
      <pre>apt-get update</pre>
    </li>
    <li> Updated? Download ispmanager:
      <pre>wget "http://download.ispsystem.com/install.sh"
      sh install.sh</pre>
    </li>
    <li>* Once downloaded it will automatically start as you know. It'll say that it found debian-lenny/sid say "yes"</li>
    <li> type in your hostname. ex: test.awesomedomain.com</li>
    <li> then your presented with "choose installation type"</li>
    <li> select "gives you choice of software"</li>
    <li>now you'll see a list of available packages to install. When you highlight and select you may choose addition options. Below are the addition options that you should choose for each package:

      <pre>
      www ----> apache2-2.2.8-1ubuntu0.5
      smtp ----> postfix-2.5.102ubuntu1.2
      pop3 ----> dovecot-pop3d-1.0.10-1ubuntu5.1
      quota ----> leave as default
      ftp ----> vsftpd-2.0.6-1ubuntu1.1
      php ----> php5-5.2.4-2ubuntu5.6
      bind ----> bind9-9.4.2.dfsg.P2-2ubuntu0.1
      fw ----> leave as default
      mysql ----> mysql-server-5.0-5.0.51a-3buntu5.4
      webmail ----> squirrelmail-1.4.13-2ubuntu1.2
      myadmin ----> phpmyadmin-2.11.3-1ubuntu1.1
      nginx ----> disabled (enable if you need it)
      pgsql ----> disabled (i haven't tested this personally)
      rails ----> disabled (i can't get this to install with ispmanager)
      sa ----> no options
      maillist ----> disabled (enable if you need it. Choose: mailman-2.1.9-9ubuntu1)
      greylist ----> no options
      webstat ----> awstats-6.7.dfsg-1ubuntu0.1
      pgadmin ----> disabled (enable if you need it)
      </pre>

    </li>
    <li>now install</li>
</ul>
And there you have it. Everything works on ubuntu.


</div>
 </div>
</div>

<!-- ISP manager END-->

<!-- RSync Start-->
<div title="Rsync installation" id="show-rsync" style="display:none">
<div>
<div id="rsync_info" title="Rsync Instructions">
<h3>Step 1. Log in as root to your server</h3>

Use:
<ul>
<li>shell access method (SSH, telnet, etc.)</li>
<li>control panel (Cpanel, Plesk, etc.)</li>
</ul>

If you do not have root access, log in to the account you will be using to perform backups.<br><br>

Note: rsync requires read access to the files it is to back up. So, it is often executed as a root user. However, it may also work when executed from individual user accounts.

<h3>Step 2. Create an RSA encryption key</h3>


Create an RSA encryption key for use with the SSH transport. To check if a key already exists, run:<br>

<pre>
# cat ~/.ssh/id_rsa.pub
</pre>

If the file already exists, you may skip to step 3. Otherwise, create a key with the ssh-keygen utility:<br>

<pre>
# ssh-keygen -t rsa -N '' (Note: these are two single quotes)
</pre>

<h3>Step 3. Copy your RSA encryption key to the backup system</h3>
You may copy the key through the shell.<br>

<pre>
# scp ~/.ssh/id_rsa.pub {$vm->backup_licenses->rsync_license->username}@rsync1.cloudkeeper.net:keys/{$vm->hostname}/
# ssh {$vm->backup_licenses->rsync_license->username}@rsync1.cloudkeeper.net mergekeys
</pre>

<h3>Step 4. Make sure rsync is installed</h3>

Run: <br>

<pre>
# yum install rsync (for CentOS) OR
# apt-get install rsync (for Debian or Ubuntu)
</pre>

You may now test rsync by copying a small directory, such as /etc: <br>

<pre>
# rsync -avz -e ssh /etc {$vm->backup_licenses->rsync_license->username}@rsync1.cloudkeeper.net:{$vm->hostname}/
</pre>

<h3>Step 5. Add rsync as a daily cronjob</h3>

1. Log in as root.<br>

2. Execute the following command (variations listed below):<br>

<pre>
# echo 15 20 * * * root rsync -avz --exclude=/proc -e ssh / {$vm->backup_licenses->rsync_license->username}@rsync1.cloudkeeper.net:{$vm->hostname}/>> /etc/crontab
</pre>
(note: don't forget both brackets...that's >>)<br><br>

Bak up home directories:

<pre>
rsync -avz -e ssh /home {$vm->backup_licenses->rsync_license->username}@rsync1.cloudkeeper.net:{$vm->hostname}/
</pre>

Back up specific users:
<pre>
rsync -avz -e ssh ~bob ~bill ~sarah {$vm->backup_licenses->rsync_license->username}@rsync1.cloudkeeper.net:{$vm->hostname}/
</pre>

</div>
</div>
</div>
<!-- RSync End-->


<!-- Snapshot Start-->
<div title="Snapshot Backup" id="show-snapshot" style="display:none">
  <div class="modal-body">
    You receive four slots of backups stored on-site. We will snapshot your VPS once per day, as well as weekly and monthly as well as allow for one individual backup on demand. These backups are not guaranteed. We highly advise you use other backup methods as well.
  </div>
</div>
<!-- Snapshot End-->

<!-- R1Soft Start-->
<div title="R1Soft Backup" id="show-r1soft" style="display:none">
  <div>
    R1Soft provides Continuous Data Protection through a user friendly interface. R1Soft backup requires you purchase one agent per server and build a VPS to store your backups (on or offsite).
  </div>
</div>
<!-- R1Soft End-->

<!-- Softaculous Start-->
<div title="Softaculous" id="show-softaculous" style="display:none">
  <div>
    Softaculous is a great Auto Installer having 138 great scripts and we are still adding more. Softaculous is ideal for Web Hosting companies and it could give a significant boost to your sales. These scripts cover most of the uses a customer could ever have. We have covered a wide array of Categories so that everyone could find the required script one would need to power their Web Site. The best part is we keep on adding new scripts which we know will satisfy the needs of a User.
    <br/>
    Softaculous works with cPanel, DirectAdmin, Plesk and ISPManager. For help installing please see:
    <a href="http://www.softaculous.com/docs" target="_blank">http://www.softaculous.com/docs</a>
  </div>
</div>
<!-- Softaculous End-->

<!-- RVSkin Start-->
<div title="RVSkin Install" id="show-rvskin" style="display:none">
  <div>
  RVSkin is a multilingual, multi-theme advanced skin management software for cPanel server. RVSkin is the best choice to differ your hosting services, lesser support needed, which results in lower operating costs for your business.
  <br/>
    SSH as root to server that was registered while purchasing the license and run:
    <pre>
mkdir /root/rvadmin; cd /root/rvadmin; wget http://download.rvglobalsoft.com/download.php/download/rvskin-auto/saveto/rvauto.tar.bz2; bunzip2 -d rvauto.tar.bz2; tar -xvf rvauto.tar; perl /root/rvadmin/auto_rvskin.pl
  </pre>
  <br/>
    Answer a couple of questions on your shell, and wait until it finishes. First installation will take 2- 5 minutes to install. Installer will create a new hosting account 'rvadmin'. Don't terminate it. It will be used for internal RVSkin configuration management.
    Log in to RVSkin Manager. Both root and reseller are able to access RVSkin Manager in WHM / Plugins (at the bottom left menu). If you cannot find the RVSkin Manager menu, please close WHM and open it again.
  <br/>
    If there is no messages display on the skin, please run this command on your SSH.
<pre>rm -f /usr/local/cpanel/Cpanel/rvversion
perl /root/rvadmin/auto_rvskin.pl</pre>
  <br/>
    In RVSkin Manager:
    <ul>
      <li>Set global configuration</li>
      <li>Set default language</li>
      <li>Create default feature list for user and for reseller</li>
      <li>Set tweak setting, reseller feature control, body links, top links, help, tutorial links, and etc.</li>
      <li>Test configuration setting in 2 hosting accounts.</li>
      <li>rvadmin: this account can consider to be account belong to root</li>
      <li>reseller's client: this account will reflect setting from reseller skin manager. If it is not configured, it will remain anonymous</li>
    </ul>
    <br/>
  Please consult <a href="http://www.rvskin.com/index.php?page=public/installation" target="_blank">RVSkin Install Guide</a> for further directions.
  </div>
</div>
<!-- RVSkin End-->

<!-- Lite Speed Start-->
<div id="show-litespeed" title="LiteSpeed" style="display:none">
  <div>
{if $litespeedlicense}
<h4><strong>Litespeed License Serial : {$litespeedlicense}</strong></h4><br/>
{/if}
LiteSpeed Web Server is the leading high-performance, high-scalability web server. It is completely Apache interchangeable so LiteSpeed Web Server can quickly replace a major bottleneck in your existing web delivery platform. Litespeed is a drop in replacement for Apache on cPanel servers.
<br/><br/>
LiteSpeed Web Server Plugin for WHM is a tool to easily integrate and manage LiteSpeed web server with cPanel. Once installed, it can be accessed from cPanel WebHost Manager Plugins section.
<br/><br/>
Main functionalities:
<ol>
  <li>Install/Uninstall LiteSpeed Web Server.</li>
  <li>Build Matching PHP Binary.</li>
  <li>One click switch between Apache and LiteSpeed.</li>
  <li>Restart LiteSpeed web server and link to LiteSpeed Administration web console.</li>
</ol>
Install/Uninstall LiteSpeed Web Server Plugin for WHM
<br/><br/>
This is for the WHM plugin itself and will not affect LiteSpeed web server installation. You can have LiteSpeed web server installed before you use this plugin. Also uninstall this plugin will not affect LiteSpeed web server running.
<br/><br/>
Installation is really simple, follow the below steps as a root user
<pre>
cd /usr/src
wget http://www.litespeedtech.com/packages/cpanel/lsws_whm_plugin_install.sh
chmod 700 lsws_whm_plugin_install.sh
./lsws_whm_plugin_install.sh
rm -f lsws_whm_plugin_install.sh
</pre>
Login to WHM, "LiteSpeed Web Server Plugin for WHM" should show up in WHM "Plugins" section.
Now you can then install/manage LiteSpeed Web Server from WHM.
<br/><br/>
After your LiteSpeed web server installed, you can try to build matching php binary with LSAPI. This will assure all your php scripts still work like under Apache.
<br/><br/>
If you upgrade or reconfigure your php through WHM easyapache, then you need to rebuild matching php binary from here.
  </div>
</div>
<!-- Lite Speed End-->

<!-- WHMCS Start-->
<div title="WHMCS License" id="show-whmcs" style="display:none">
  <div>
{if $whmcslicense}
<h4><strong>WHMCS License Serial : {$whmcslicense}</strong></h4><br/>
{/if}
WHMCS is an all-in-one client management, billing &amp; support solution for online businesses. Handling everything from signup to termination, WHMCS is a powerful business automation tool that puts you firmly in control. Please note these licenses can only be used on our servers and not externally.
  </div>
</div>


<link href="./assets/css/jquery-ui.css" media="screen" rel="stylesheet" type="text/css" />

<div id="show-cpanel" title="cPanel installation" style="display:none">
<div>
<b>Important:</b> cPanel and WHM cannot be installed on a production web server; you must use a server with a freshly installed operating system.<br><br>

It is important to consider how many sites you plan to host with your web server. For example, if your server is going to host a lot of websites, each with its own set of email addresses and databases, you will need more than nodes then if you wish to only host one or two sites.<br><br>

cPanel recommends a minimum of 266Mhz and 256MB of RAM, so a one node server should serve as a final minimum. Please note this must be installed on a freshly installed CentOS or CloudLinux server, we provide images with cPanel already installed.<br><br>

<b>Install instructions</b><br><br>

To begin your installation on a fresh CentOS or CloudLinux server, use the following commands:<br><br>

yum install perl wget<br>
cd /home &ndash; Opens the directory /home.<br>
wget -N http://layer1.cpanel.net/latest &ndash; Fetches the latest installation file from the cPanel servers.<br>
sh latest &ndash; Opens and runs the installation files.<br>
/usr/local/cpanel/cpkeyclt &ndash; Activates your license after installation.<br><br>


If you elect to use a prebuilt cPanel image, please run /scripts/upcp to update your cPanel to the newest version.<br><br>

For more information, please see <a href="http://docs.cpanel.net/twiki/bin/view/AllDocumentation/InstallationGuide/WebHome">http://docs.cpanel.net/twiki/bin/view/AllDocumentation/InstallationGuide/WebHome</a>
</div>
</div>


 
<script>

var help=["cpanel","ispmanager","rsync","snapshot","r1soft","softaculous","rvskin","litespeed","whmcs"];


help.forEach(function(item, i, help ) {

$( "#show-"+item ).dialog( { autoOpen: false, width: 800, height: 500, modal: true, 

open : function() {
	jQuery(".ui-dialog-content").scrollTop(0);
     }
});


$( "#help-show-"+item ).click(function() {
	jQuery( "#show-"+item ).dialog( "open" );
});

});

</script>

<!-- WHMCS End-->
